<template>
    <v-container class="lighten-5" fluid>
        <v-row class="mb-12" justify="center" no-gutters>
            <vue-clip :options="options" :on-added-file="addedFile" :on-total-progress="totalProgress"
                      :on-complete="complete">
                <template slot="clip-uploader-action">
                    <div class="area">
                        <div id="dropZone" class="dz-message"><h2> Add files to convert</h2></div>
                    </div>
                </template>
            </vue-clip>
        </v-row>

        <v-row justify="end" style="padding-bottom: 1em; padding-right: 1em">
            <v-btn height="50" rounded v-if="files.length > 0 && files.length > filesConverted" v-on:click="convertAllFiles()">Convert all files</v-btn>
        </v-row>

        <v-row class="mb-12" justify="center"  no-gutters v-if="files.length > 0">
            <v-list color="#ededed" rounded>
                <transition-group name="slide-fade">
                    <v-list-item
                            v-for="(file, index) in files"
                            :key="`${file.name}+${index}`"
                            @click=""
                    >

                        <v-list-item-icon size="100">
                            <v-img
                                    :src="file.dataUrl"
                            ></v-img>
                        </v-list-item-icon>

                        <v-list-item-content>
                            <v-list-item-title style="padding: 5px; font-weight: bold" v-text="file.name"></v-list-item-title>

                            <v-list-item-subtitle>
                                <v-row>
                                    <v-col>
                                        <div v-if="file.uploaded">
                                            <div style="padding: 5px" >
                                                <strong>Uploaded: </strong><v-icon color="success">fas fa-check</v-icon>
                                            </div>
                                            <div style="padding: 5px" >
                                                <strong>Date Uploaded: </strong>{{file.fileStatus.dateUploaded | formatDate}}
                                            </div>
                                            <div style="padding: 5px" >
                                                <strong>Uploaded by service: </strong>{{file.fileStatus.storedByService}}
                                            </div>
                                        </div>
                                    </v-col>
                                    <v-col>
                                        <div v-if="file.converted">
                                            <div style="padding: 5px" >
                                                <strong>Converted: </strong><v-icon color="success">fas fa-check</v-icon>
                                            </div>
                                            <div style="padding: 5px" >
                                                <strong>Date Converted: </strong>{{file.fileStatus.dateConverted | formatDate}}
                                            </div>
                                            <div style="padding: 5px" >
                                                <strong>Converted by service: </strong>{{file.fileStatus.convertedByService}}
                                            </div>
                                        </div>
                                    </v-col>

                                </v-row>





                                <!--                        <div v-if="file.status !== 'success'">-->
                                <div v-show="file.status !== 'success'" >
                                    <v-progress-linear
                                            v-model="progr"
                                            height="20"
                                            color="success"
                                    >
                                        <strong>{{ Math.ceil(file._file.upload.progress) }}%</strong>
                                    </v-progress-linear>
                                </div>
                            </v-list-item-subtitle>
                        </v-list-item-content>

                        <v-list-item-action v-if="file.uploaded">
                            <v-row>
                                <!--                                        :hint="`${file.selectedOutputFormat.text}, ${file.selectedOutputFormat.value}`"-->
                                <v-col v-if="file.uploaded && !file.converted && !file.converting">
                                    <v-select
                                            height="50"
                                            v-model="file.selectedOutputFormat"
                                            :items="file.extensionOptions"
                                            item-text="text"
                                            item-value="value"
                                            label="Select output format"
                                            solo
                                    ></v-select></v-col>

                                <v-col>
                                    <v-row>
                                        <v-btn height="50" rounded v-if="file.uploaded && !file.converted && !file.converting" v-on:click="convertFileClicked(file)">Convert file</v-btn>
                                        <v-btn height="50" rounded v-if="file.uploaded && file.converted" v-on:click="downloadClicked(file)">Download</v-btn>
                                        <v-progress-circular
                                                v-if="file.uploaded && file.converting"
                                                indeterminate
                                                color="primary"
                                        ></v-progress-circular>
                                        <v-btn height="50" rounded v-if="file.uploaded && !file.converted && !file.converting" style="margin-left: 10px" v-on:click="deleteFileClicked(index)" ><v-icon color="red">fas fa-trash</v-icon></v-btn>
                                    </v-row>
                                    <v-row>

                                    </v-row>
                                </v-col>
                            </v-row>
                        </v-list-item-action>

                    </v-list-item>
                </transition-group>
            </v-list>
        </v-row>
    </v-container>
</template>
<style>
    .area {
        width: 100%;
        padding: 15px;
        border: 1px solid #333;
        background: rgba(0, 0, 0, 0.7);
        border-radius: 5px;
    }

    .area:hover {
        background: rgba(0, 0, 0, 0.8);
        cursor: pointer;

    }

    #dropZone {
        border: 2px dashed #bbb;
        -webkit-border-radius: 5px;
        border-radius: 5px;
        padding: 50px;
        text-align: center;
        font: 16pt bold arial;
        color: #bbb;
    }
    /* Enter and leave animations can use different */
    /* durations and timing functions.              */
    .slide-fade-enter-active {
        transition: all 1s ease;
    }
    .slide-fade-leave-active {
        transition: all 0s cubic-bezier(1.0, 0.5, 0.8, 1.0);
    }
    .slide-fade-enter, .slide-fade-leave-to
        /* .slide-fade-leave-active below version 2.1.8 */ {
        transform: translateX(10px);
        opacity: 0;
    }
</style>

<script>
    import moment from "moment";
    import {convertFile, downloadFile} from "../../util/api-provider";
    import Vue from 'vue';
    import {getLoggedUser, getToken} from "../../util/auth";

    export default {
        data: () => ({
            options: {
                url: '/files-core/upload',
                paramName: 'file',
                headers:{
                    Authentication:""
                }
            },
            files: [],
            progr: 0,

            extensions: 'gif,jpg,jpeg,png,webp',
            postAction: '/upload/post',
            accept: 'image/png,image/gif,image/jpeg,image/webp',
            dialog: false,
            size: 1024 * 1024 * 10,
            thread: 3,
            filesUploaded: 0,
            filesConverted: 0
        }),
        filters: {
            formatDate: function (value) {
                if (value) {
                    var date = Date.parse(value);
                    return moment(date).format('MM/DD/YYYY hh:mm:ss')
                }
                return value
            }
        },
        computed: {

        },

        watch: {

        },

        created() {
            this.options.headers.Authentication = getToken()

            this.extensionItemsMap = new Map();
            this.extensionItemsMap.set()

        },


        methods: {
            addedFile(file) {
                Vue.set(file, "uploaded", false);
                Vue.set(file, "converting", false);
                Vue.set(file, "converted", false);

                if(file.type.startsWith("audio")){
                    file.extensionOptions = [
                        {
                            text: ".MP3",
                            value: "audio/mp3"
                        }
                    ]
                }

                if(file.type.startsWith("video")){
                    file.extensionOptions = [
                        {
                            text: ".MP3",
                            value: "audio/mp3"
                        },
                        {
                            text: ".WEBM",
                            value: "video/webm"
                        }
                    ]
                }

                if(file.type.startsWith("image") || file.type.startsWith("application/vnd.ms-powerpoint") ||
                    file.type.startsWith("application/msword") || file.type.startsWith("application/vnd.openxmlformats-officedocument.wordprocessingml.document")
                || file.type.startsWith("application/vnd.openxmlformats-officedocument.wordprocessingml.presentation")){
                    file.extensionOptions = [
                        {
                            text: ".PNG",
                            value: "image/png"
                        }
                    ]
                }

                file.selectedOutputFormat = file.extensionOptions[0].value

                this.files.push(file)
            },

            totalProgress(progress, totalBytes, bytesSent) {
                this.progr = progress
            },
            convertFileClicked(file){
                file.converting = true;
                this.$forceUpdate();
                convertFile(file.fileStatus.id, file.fileStatus.originalFile, file.selectedOutputFormat).then(function (response) {
                    file.fileStatus.convertedByService = response.data.conversionTicket.serviceInfo.serviceHostName + ";" + response.data.conversionTicket.serviceInfo.serviceHostIp;
                    file.fileStatus.outputFormat = response.data.outputFormat;
                    file.name = response.data.outputFile.fileName;
                    file.fileStatus.dateConverted = response.data.dateConverted;
                    file.converted = true;
                    file.converting = false;
                })
                this.filesConverted = this.filesConverted + 1
            },

            downloadClicked(file){
                downloadFile(file.fileStatus.id)
            },

            complete(file, status, xhr) {
                file.fileStatus = JSON.parse(xhr.response);
                file.uploaded = true;
            },

            convertAllFiles(){
                this.files.forEach(file => {
                    if(!file.converted)
                    this.convertFileClicked(file)
                })
            },

            deleteFileClicked(index){
                this.files.splice(index, 1)
            }
        }
    }
</script>

